#include <cairo.h>
#include "glitz-glx.h"
#include "glitz.h"

int main(int argc, char *argv[]) {

    cairo_t *cr = cairo_create ();
    void* sf;
    Display *dpy;
    Window win;
    int scr;
    glitz_format_t *format;

    int use_glitz = 1;
    int destroy_gl_surface = 0;
    if ( use_glitz ) {

        dpy = XOpenDisplay (0);
        scr = DefaultScreen (dpy);
        win = XCreateSimpleWindow (dpy, DefaultRootWindow(dpy), 0, 0, 400, 400, 0, 0, 0);

        format = glitz_glx_find_standard_format (dpy, scr,
                                                 GLITZ_FORMAT_OPTION_ONSCREEN_MASK,
                                                 GLITZ_STANDARD_RGB24);
                                                             
        sf = glitz_glx_surface_create_for_window (dpy, scr, format, win);

        cairo_set_target_gl (cr, (glitz_surface_t *)sf);

    } else {   // use pixman
        
        int width = 400;
        int height = 400;
        sf = cairo_surface_create_for_image( (char *) malloc( width * height * 4),
                                             (cairo_format_t) 0,
                                             width, height,
                                             width * 4);

        cairo_set_target_surface (cr, (cairo_surface_t *)sf);

    }

    int i = 0;
    for ( i = 0; i < 1000000; i++) {
      cairo_show_text(cr, "x");
      if ( use_glitz && destroy_gl_surface ) {
          glitz_surface_destroy ((glitz_surface_t *)sf);
          sf = glitz_glx_surface_create_for_window (dpy, scr, format, win);
          cairo_set_target_gl (cr, (glitz_surface_t *)sf);
      }
    }

    if ( use_glitz ) {
        glitz_surface_destroy ((glitz_surface_t *)sf);
    } else {
        cairo_surface_destroy ((cairo_surface_t *)sf);
        XDestroyWindow (dpy, win);
    }
    cairo_destroy (cr);

    exit(-1);
}
